#include <Pilot.h>
#include "DropModule.h"
#define MaxLength 22 /* 9888 = MMMMMMMMMDCCCDXXXVIII */
// M, DC, LX, VI

DWord PilotMain(Word cmd, Ptr cmdPBP, Word launchFlags) {
	tDropLaunchCmdParamPtr param = (tDropLaunchCmdParamPtr)cmdPBP;
	char work[MaxLength];
	unsigned short arabic; // number for arabic
	unsigned short number; // number for each columns
	unsigned short index;  // current columns in roman
	if(cmd == dDropLaunchSupportCmd) {
		return dYes_Support;
	} else if(cmd == dDropLaunchCmd) {
		// set as default settings
		param->resultBehavior = eBehavior_Do_Nothing;
		param->resultText = 0;
		// dispatch...
		switch (param->selector) {
		case 0:
			if(param->srcTextLength >= MaxLength)
				return 1; // error
			MemMove (work, param->srcText, param->srcTextLength);
			work[param->srcTextLength] = '\0';
			arabic = StrAToI(work);
			if(0 < arabic && arabic < 10000) {
				// translate from arabic number to roman number
				index = (arabic < 10) ? 1 : (arabic < 100) ? 2 : (arabic < 1000) ? 3 : 4;
				if(index != param->srcTextLength)
					return 1;
				index = 0;
				number = arabic / 1000;
				while(number-->0)
					work[index++] = 'M'; // 1000
				number = (arabic % 1000) / 100;
				if(number == 9) {
					work[index++] = 'C'; // 100
					work[index++] = 'M'; // 1000
				} else if(number == 4) {
					work[index++] = 'C'; // 100
					work[index++] = 'D'; // 500
				} else {
					if(number >= 5) {
						work[index++] = 'D'; // 500
						number -= 5;
					}
					while(number-->0)
						work[index++] = 'C'; // 100
				}
				number = (arabic % 100) / 10;
				if(number == 9) {
					work[index++] = 'X'; // 10
					work[index++] = 'C'; // 100
				} else if(number == 4) {
					work[index++] = 'X'; // 10
					work[index++] = 'L'; // 50
				} else {
					if(number >= 5) {
						work[index++] = 'L'; // 50
						number -= 5;
					}
					while(number-->0)
						work[index++] = 'X'; // 10
				}
				number = (arabic % 10);
				if(number == 9) {
					work[index++] = 'I'; // 10
					work[index++] = 'X'; // 100
				} else if(number == 4) {
					work[index++] = 'I'; // 10
					work[index++] = 'V'; // 50
				} else {
					if(number >= 5) {
						work[index++] = 'V'; // 50
						number -= 5;
					}
					while(number-->0)
						work[index++] = 'I'; // 10
				}
				work[index] = '\0';

				// copy the string to result area
				param->resultText = (Char*) MemPtrNew(index);
				param->resultTextLength = index;
				MemMove (param->resultText, work, index);
				param->resultBehavior = eBehavior_Replace;
				return 0;
			} else if (arabic == 0) {
				// translate from roman number to arabic number
				index = 0;
				arabic = 0;
				while(work[index] == 'M' || work[index] == 'm') {
					arabic += 1000;
					index++;
				}
				if(work[index] == 'D' || work[index] == 'd') {
					arabic+=500;
					index++;
				}
				if(work[index] == 'C' || work[index] == 'c') {
					if(work[index+1]=='M' || work[index+1] == 'm') {
						arabic+=900;
						index+=2;
					} else if(work[index+1]=='D' || work[index+1] == 'd') {
						arabic+=400;
						index+=2;
					} else {
						while(work[index] == 'C' || work[index] == 'c') {
							arabic += 100;
							index++;
						}
					}
				}
				if(work[index] == 'L' || work[index] == 'l') {
					arabic+=50;
					index++;
				}
				if(work[index] == 'X' || work[index] == 'x') {
					if(work[index+1]=='C' || work[index+1] == 'c') {
						arabic+=90;
						index+=2;
					} else if(work[index+1]=='L' || work[index+1] == 'l') {
						arabic+=40;
						index+=2;
					} else {
						while(work[index] == 'X' || work[index] == 'x') {
							arabic += 10;
							index++;
						}
					}
				}
				if(work[index] == 'V' || work[index] == 'v') {
					arabic+=5;
					index++;
				}
				if(work[index] == 'I' || work[index] == 'i') {
					if(work[index+1]=='X' || work[index+1] == 'x') {
						arabic+=9;
						index+=2;
					} else if(work[index+1]=='V' || work[index+1] == 'v') {
						arabic+=4;
						index+=2;
					} else {
						while(work[index] == 'I' || work[index] == 'i') {
							arabic += 1;
							index++;
						}
					}
				}
				if(index != param->srcTextLength) {
					return 1; // error, not roman number string
				}
				if(arabic < 10000) {
					index = (arabic < 10) ? 1 : (arabic < 100) ? 2 : (arabic < 1000) ? 3 : 4;
					param->resultText = (Char*) MemPtrNew(index);
					param->resultTextLength = index;
					StrIToA(param->resultText, arabic);
					param->resultBehavior = eBehavior_Replace;
					return 0;
				} else {
					return 1; // over 10000
				}
			} else {
				return 1; // negative or zero
			}
		default:
			break;
		}
	return 0; // never executed.
	} else if(cmd == sysAppLaunchCmdNormalLaunch) {
	}
}
